(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'melon-form', 'react-addons-update'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('melon-form'), require('react-addons-update'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.melonForm, global.reactAddonsUpdate);
        global.createReducer = mod.exports;
    }
})(this, function (exports, _melonForm, _reactAddonsUpdate) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _defineProperty(obj, key, value) {
        if (key in obj) {
            Object.defineProperty(obj, key, {
                value: value,
                enumerable: true,
                configurable: true,
                writable: true
            });
        } else {
            obj[key] = value;
        }

        return obj;
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    exports.default = function (model, initialValue, reducers) {
        return (0, _melonForm.createReducer)(model, initialValue, _extends({}, reducers, _defineProperty({}, _melonForm.actionTypes.CHANGE, function (state, action, next) {
            var _action$payload = action.payload,
                name = _action$payload.name,
                value = _action$payload.value;


            if (value === '') {
                return (0, _reactAddonsUpdate2.default)(state, {
                    value: {
                        $set: _melonForm.dataPath.deleteIn(state.value, name)
                    }
                });
            }

            return next(state, action);
        })));
    };
});
//# sourceMappingURL=createReducer.js.map
